Summary:	Perform automatic tests against a RHEL's sysreport
Name:		checksysreport
Version:	1.2
Release:	1.5
License:	GPL
Group:		Application/Tools
URL:		https://www.checksysreport.com/
Source0:	%{name}-%{version}-0.tar.bz2
Patch0:		checksysreport-suse-wwwdir.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}
BuildArchitectures: noarch
Requires:	python redhat-rpm-config
%if 0%{?rhel_version} || 0%{?centos_version} || 0%{?fedora_version}
Requires:	pygtk2-libglade, pygtk2, postgresql-python
%define		_wwwroot	/var/www
%define		_htdocsdir	html
%define		_wwwusr		apache
%define		_wwwusr		apache
%endif
%if 0%{?suse_version}
Requires:	python-gtk python-gtkglext postgresql-plpython
BuildRequires:	pwdutils
%define		_wwwroot	/srv/www
%define		_htdocsdir	htdocs
%define		_wwwusr		wwwrun
%define		_wwwgrp		www
%endif

Conflicts:	rhnapiwrap

%description
Some tools to help people doing tech support for RHEL machines.

%package server
Requires: checksysreport,postgresql-server,php,php-pgsql,httpd,threadpool
Requires:	pwdutils
Group: Application/Tools
Summary: This is the server side of checksysreport
%description server
The checksysreport server uses a postgresql database to stores information
about rhn packages. Ideally, the idea would be to have one such server per
offices to reduce bandwith. It is suppose to cope with concurrent access.

%package rhn-scraper
Requires: checksysreport,python-mechanize
Group: Application/Tools
Summary: This package makes download rhn package from the command line
%description rhn-scraper
checksysreport-rhn-scraper deliver some class that act as a browser
accessing the rhn web site. A simple package downloader script
is included.

%pre server
if [ $1 = 1 ] ; then
echo "Creating checksysreport user"
%if 0%{?suseversion}
/usr/sbin/groupadd checksysreport
/usr/sbin/useradd -g checksysreport checksysreport
%endif
%if 0%{?rhel_version} || 0%{?centos_version} || 0%{?fedora_version}
/usr/sbin/useradd checksysreport
%endif
fi


%post server
echo "Read /usr/share/doc/checksysreport-server-%{version}/README.server to know how to enable the server."
%if 0%{?suse_version}
/usr/sbin/usermod -A checksysreport %{_wwwusr} || :
%endif
%if 0%{?rhel_version} || 0%{?centos_version} || 0%{?fedora_version}
/usr/sbin/usermod -a -G checksysreport %{_wwwusr}
%endif
chmod g+s %{_wwwroot}/checksysreport-spool

%postun server
if [ $1 = 0 ] ; then
  echo "Removing checksysreport user"
  /usr/sbin/userdel checksysreport
  echo "Removing checksysreport group"
  /usr/sbin/groupdel checksysreport 
  echo "Removing spool directory"
  /bin/rm -rf %{_wwwroot}/checksysreport-spool/
fi

%prep
%setup -q -n  %{name}-%{version}-0
%if 0%{?suse_version}
%patch0
%endif

%build

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc README COPYING CHANGELOG
%attr(0755,root,root) /usr/bin/checksysreport
%attr(0755,root,root) /usr/bin/yadarh
%dir /usr/share/%{name}
%attr(0644,root,root) /usr/share/%{name}/globals.py*
%attr(0644,root,root) /usr/share/%{name}/rhnapiwrap.py*
%attr(0644,root,root) /usr/share/%{name}/sysreportChecker.py*
%attr(0644,root,root) /usr/share/%{name}/checksysreport_wrapper.py*
%attr(0644,root,root) /usr/share/%{name}/yadarh.glade
%attr(0644,root,root) /usr/share/%{name}/checksysreportrc
%attr(0644,root,root) /usr/share/man/man1/checksysreport.1.gz
%attr(0644,root,root) /usr/share/man/man1/yadarh.1.gz
%attr(0755,root,root) /usr/share/%{name}/plugins
%attr(0644,root,root) /usr/share/%{name}/plugins/sample.py

%files server
%defattr(-,root,root,-)
%doc README.server
%attr(0644,root,root) /usr/share/%{name}/bz.sql
%attr(0644,root,root) /usr/share/%{name}/base.sql
%attr(0755,root,root) /usr/share/%{name}/post-install-action.sh
%attr(0755,root,root) /usr/share/%{name}/dump-and-restore.sh
%attr(0755,root,root) %{_bindir}/fill-cache-packages
%attr(0755,root,root) %{_bindir}/fill-cache-advisory
%attr(0755,root,root) %{_bindir}/wcs
%attr(0775,%{_wwwusr},checksysreport) %{_wwwroot}/checksysreport-spool
%dir %{_wwwroot}/%{_htdocsdir}/wcs
%attr(0755,checksysreport,root) %{_wwwroot}/%{_htdocsdir}/wcs
%attr(0644,checksysreport,root) %{_wwwroot}/%{_htdocsdir}/wcs/index.ihtml
%attr(0644,checksysreport,root) %{_wwwroot}/%{_htdocsdir}/wcs/index.php
%attr(0644,checksysreport,root) %{_wwwroot}/%{_htdocsdir}/wcs/ok.ihtml
%attr(0644,checksysreport,root) %{_wwwroot}/%{_htdocsdir}/wcs/rhn-base.css
%attr(0644,checksysreport,root) %{_wwwroot}/%{_htdocsdir}/wcs/template.inc.php

%files rhn-scraper
%attr(0644,root,root) %{_datadir}/%{name}/rhn_scraper.py*
%attr(0755,root,root) %{_bindir}/download_rhn_package

%changelog
* Tue Mar 29 2011 Carsten Schoene <cs@linux-administrator.com> - 1.2-1
- update to version 1.2
 - Support was added for RHEL6's sosreport.
 - pgdb is used instead of _pg, so there's no need to escape SQL sentences.

* Thu Jan 07 2010 Carsten Schoene <cs@linux-administrator.com> - 1.0-7
- update to release 7
 - Kernel detection does not handle packages coming from
   a beta channel as supported anymore
 - Adding checksysreport-rhn-scraper as a sub package.
 - Coping with yadarh's xmlrpclib.ProtocolError
 - Coping with yadarh's xmlrpclib.Fault
 - Coping with yadarh's "Could not find session with id"
 - Plugins can be triggered in top,bottom or package hooks.
 - wcs does not accept sysreport with an open parenthesis
   in the name anymore.

* Mon Jul 06 2009 Pierre Amadio <pamadio@redhat.com>
Version 1.0 Release 6
- dmidecode information about the system is printed.
- plugins can be automatically launched.
- configuration section in man page.
- yadarh now always select RHEL 5 once started.
- some packages were not considered as coming from rhn when
  present in several rhn channels. (see IT#302938)
- Double clicking on a channel entry in yadarh (instead
  of a package) does not try to open a browser anymore.
- wcs spool was stuck if there was a problem with the 
  local mta.


* Sun Feb 08 2009 Pierre Amadio <pamadio@redhat.com>
- yet another utf8 bug (globals.py, line 995, in generate_report).
- sos's new format for installed-rpms was not recognised (cf BZ#455096)
- testing if the current package looks more recent than the one
  present on rhn.
- rpm_is_younger_than now uses rpm labelCompare
- workaround for an advisory appearing twice (RHSA-2008:0030 for 430732
  and 431141)
- automatic z-stream base channel list in yadarh
- changing xmlrpc timeout to 300 seconds when filling cache
  so large advisory such as RHEA-2009:0272 can be handled.

* Mon Jan 05 2009 Pierre Amadio <pamadio@redhat.com>
- fill-cache-packages crashed with key errors when database
  insert were too slow because of swapping.
- typo (LOG_DEBUF) in sysreportChecker.py for RHEL4.
- changelogs diff were wrong when the newest package had
  a lower package id than the freshest (wich may occur
  with package in beta channels).
  See kernel-2.6.18-120.el5.i686.rpm (460905)
  vs  kernel-2.6.18-92.1.17.el5.i686.rpm (463602)
- converting string in utf8 and escaping "'" before inserting
  bugzilla data with fill-cache-advisory(cf BZ455245)
- closing database connection when an error occured in
  fill-cache-advisory
- fill-cache-advisory: atomic per advisory (not per channel anymore)
- failled rhn login in fill-cache-advisory lead to another attempt,
  untill it works (or the loop limit is exceeded).

* Mon Sep 01 2008 Pierre Amadio <pamadio@redhat.com>
- Warning for known kernel issues are printed.
- wcs's spool was stuck when the sosreport was empty or
  the archive was corrupted.
- wcs does not accept to extract file with a '..' in the 
  name anymore.
- fill-cache-packages remove channel not existing in rhn
  anymore from the local database.
- fill-cache-packages works with threadpool 1.2.4
- fill-cache-advisory did not stop when max_attempt was reached.
- added a wrapper class so that checksysreport can be generated
  non interactively.
- Yadarh can run when there is no connexion to rhn available.
  In this case, the changelogs diff are not available.
- AS2.1 sysreport made on ia64 were not usable. (cf IT#212541)


* Tue Jan 29 2008 Pierre Amadio <pamadio@redhat.com>
- fill_cache_packages did not cope with xmlrpc server errors.
- yadarh and checksysreport are z-stream aware.
- fill_cache_packages did not work with rhn satellite. 
  Thanks to Michael Roessler for the fix.
- base channel detection is first attempted using rhn.
  Thanks to Michael Roessler for the patch.
- SQL type for package version and release are now text (no lenght limitation).
- yadarh quit when there is an exception in the background thread.
- yadarh does not crash anymore when searching for string that countain
  regular expression caracter used as regular caracter (expl: 'c++')


* Thu Oct 11 2007 Pierre Amadio <pamadio@redhat.com>
- Package release may be longer than 25 character.
  by example:
  xml-commons-resolver12-1.2-0.1.20060226svn.0jpp.ep1.3.noarch.rpm
- Filling cache can cope with orphan channels (jbappplatform-4-zip).
- Removing mention of rhn/login (-l/-p) option in checksysreport man page.
- Adding plugin -p option in checksysreport.
- Adding rhnapiwrap listDependencies method.
- A bug where a diff changelog failed if only 1 changelog was cached
  has been fixed.
- transaction isolation level has been set to serializable when updating
  the cache for up2date packages.
- fill-cache-advisory and fill-cache-packages now use a max_attempt
  variable so the script will kills itself if it iterate more than
  max attempt during the while true loops. 
- RHEL5.1 are now recognised as such, thanks to Bryn Reeves.

* Sat May 13 2007 Pierre Amadio <pamadio@redhat.com>
- There is a checksysreport-server package that share its cache
  to checksysreport clients using postgresql.
- The server also accept sysreports to analyse from a web page.
- A cosmetic bug when copying changelogs diff in yadarh has been fixed.
- Fetching data from rhn is threaded.
- Client can be configured to use a satellite instead of rhn.redhat.com
- Makefile works for 108.redhat.com's svn
- Cleaner packaging, thanks to David Juran.


* Tue Mar 27 2007 Pierre Amadio <pamadio@redhat.com>
- RHEL5 is supported \o/
- The password is not shown anymore when being prompted by checksysreport.
- Encoding all changelogs stuff in utf8 before printing them.
- Sometimes the installed-rpms does not show the architecture even for 
  RHEL4 (cf crm#911298)

* Fri Aug 04 2006 Pierre Amadio <pamadio@redhat.com>
- In yadarh, a comparaison of rpm_id failed because of wrong type detection 
  Because of that the right window countained the same rpm as the selected one.
- There was a new problem regarding unicode encoding with some data in the
  changelogs.
  They are converted to utf8 now before being printed.
- As fasttrack packages are not associated to any advisory, checksysreport
  show a diff of the changelog for fasttrack packages that are newer than 
  the installed one.
- There was an obscure problem with guessing installed package pid when there
  was existing fastrack package because the current packaged was though to 
  belong to the fastrack channel.
- There is now an arbitrary list of channels we dont take care anymore
  in order to save time when fetching info from rhn.
- The list of erratas is fetched using the rhn api and not from the web page 
  anymore so rhnwebclient.py is now useless !

* Thu Jul 27 2006 Pierre Amadio <pamadio@redhat.com>

- Since rhn 4.1.0 fetching changelogs from the web does not work anymore
  using rhnwebclient.
  Luckily, it looks like BZ#167169 has been fixed, so we can use the rhn
  api instead.
- Because of the above issue, the cache could countain empty changelogs.
  In order to workaround this, the changelog cache directory is removed 
  if there is no v01r5CleanCacheFlag (and such a flag is created once the 
  cleaning is done).
- Since rhn 4.1.0 get_rpm_infos was broken.
  as well as other part where an rpm_id was used to be a string.

* Thu Jul 20 2006 Pierre Amadio <pamadio@redhat.com>

- checksysreport works with SoSreport archive too.
- Typo in man page led to authentication failure in case you
  used quote as login or password delimitter.
- Since rhn 4.1.0 rhnapiwrap logs in as soon as an instance is created.
- Since rhn 4.1.0 some channel appearing as existing according to the rhn api
  actually do not exist; so rhnpiwrap ignore the 210 error code when asking for non
  existing channel software package list.

* Thu Apr 27 2006 Pierre Amadio <pamadio@redhat.com>

- guessing ppc release before i386 (cf crm#871484).
  This has also been changed for RHEL4.
- up2date configuration's serverURL variable 
  can ends up with a semi colon. 
- search by rpm name is not case sensitive anymore.
- pressing the "list package" several times ended up
  with rpm shown twice in the left tree view.
- right click menu on the left rpm window appears
  only for rpm, not channels.
- release was not recognised for Rhel3 Desktop.
- Checking architecture try to detect ia64 first for RHEL4.
  (cf crm#841874)


* Sun Feb 11 2006 Pierre Amadio <pamadio@redhat.com>

- clock cursor appears as soon as a job is requested.
- advisories are sorted when copyed in clipboard.
- yadarh man page has more content.


* Mon Feb 06 2006 Pierre Amadio <pamadio@redhat.com>

- Checksysreport does not warn against obsolete optik module
  when ran on RHEL4 anymore.
- Yadarh does not warn against obsolete timeout module anymore.
- Yadarh has a nice "waiting" mouse cursor while waiting for info.
- Right Click menu on all TreeView
- Double Click on most TreeView
- Result view can be toggled to take all the available space.
- yadarh man page added.

* Sun Jan 29 2006 Pierre Amadio <pamadio@redhat.com>

- Checksysreport prompt for login and password if they do not
  exists. Thanks to Jose Maria Plans
- checksysreport -d works again.
- more random fixes.
- yadarh is usable now (changelogs ands erratas report).
- treeview are ordered.
- right click on a errata result pop up a menu to copy the 
  bug or errata url.

* Wed Jan 25 2006 Pierre Amadio <pamadio@redhat.com>

- rhnapiwrap is now included in checksysreport.
- Since RHN v 4.0.5 the web login access have been slightly changed.
  This has generated changes in the rhnwebclient login mechanism.
- s390  and s390x are supposed to work now. (cf crm#725028)
- A graphical tool (yadarh) is included as well.

* Thu Nov 03 2005 Pierre Amadio <pamadio@redhat.com>

- custom kernel module test failed when a /lib/modules/<kernel-version> 
  directory was removed. Cf crm#712018

* Mon Oct 31 2005 Pierre Amadio <pamadio@redhat.com>

- Kernel modules that appears recompiled according to rpm-Va are shown.
  There is also a short test stating if they were loaded or not.

* Wed Oct 12 2005 Pierre Amadio <pamadio@redhat.com>

- Use common routines for all filenames and access to configuration data.
  Clearing your cache before upgrading to 0.0-10 is recommended.
  Thanks to Martin Poole.
- Changelog data are only fetched from the network if they are not already
  known. Thus, checksysreport -g takes less time to run.
  Thanks to Martin Poole.
- Comparing package id was made as if package id were string and not integer.
  This made changelog comparison fail (see crm#699032 and kernel
  changelog)
- Finding rpm info accrording to a package id failed in 
  get_package_by_pid because of the same int vs string comparison.
  (see what happend with checksysreport -d 323370 -d 61248)


* Thu Sep 01 2005 Pierre Amadio <pamadio@redhat.com>

- ** WARNING **
  Removing former cached files is mandatory in order to switch
  to version 0.0-9 

- Bugs fixed by adivisory not applyed on the system are displayed.
- The rhn api has changed a key in the channel since rhn  4.0
  (package_arch_label instead of package_arch_name). 
- The api is now used to fetch the file listed in a rpm (as the featured is
  now working on rhn). 
- Rhel4 desktop is supposed to be supported.


* Wed Jun 22 2005 Pierre Amadio <pamadio@redhat.com>

- The previous fix supposed to handle the 'uname' file starting with 'uname -a'
  and not the actual output of the command was not good enough.

* Fri Jun 17 2005 Pierre Amadio <pamadio@redhat.com>

- checking if up2date settings (noSSLServerURL and serverURL) ends up
  with /XMLRPC
- Some new version of sysreport add new line in the output of uname -a
  and lsmod that were not understandable by checksysreport.
  (cf new sysreport generated on RHEL4 with sysreport-1.3.15-2)

* Mon May 30 2005 Pierre Amadio <pamadio@redhat.com>

- A man page has been created.
- A list of uninstalled erratas is printed for each obsolete rpm.
- If the running kernel is not up2date, then changelog entry existing only in
  the up2date kernel's changelog  are printed.
- Added options -no-changelog, --full-changelog and --diff-changelog

* Tue May 17 2005 Pierre Amadio <pamadio@redhat.com> 

- Kernel version and module checking: 
  If the current running kernel match a valid rhn kernel, there is a a
  check performed in order to detect third party module loaded.
  A tainted kernel also generate a warning

* Sat May 14 2005 Pierre Amadio <pamadio@redhat.com>

- When displaying obsoletes rpm, the channel associated with the supposed
  correct rpm is printed as well as the rpm name.
- Installing a rhel3's syreport on a AS2.1 is supposed to work now
  cf crm#536702
- Checking architecture try to detect ia64 first for RHEL3.

* Fri Apr 8 2005 Pierre Amadio <pamadio@redhat.com>

- This is supposed to work for AS2.1 as well as for RHEL3 where
installed-rpms file does not contain arch information.

* Tue Mar 29 2005 Pierre Amadio <pamadio@redhat.com>

- Caching data has been optimized so there is one file per channel and we only 
load data related to channel we need. Since then, checking a sysreport last 
only a couple of seconds instead of a minute. 
Thanks to Thomas Uebermeier for the idea.
- There is an architecture check in get_obsolete_rpms that prevent some
(but strangely enough not all) obsolete rpms appearing twice in the
report.  Thanks to Bastien Nocera for the hint.

* Thu Mar 17 2005 Pierre Amadio <pamadio@redhat.com> - 
- Initial build.

